--- Baixades/policycoreutils.HEAD.ca.po	2009-05-16 16:10:56.000000000 +0200
+++ Escriptori/policycoreutils.HEAD.ca.po	2009-05-16 16:00:04.000000000 +0200
@@ -5,6 +5,7 @@
 #
 # Josep Puigdemont Casamajó <josep.puigdemont@gmail.com>, 2006.
 # Xavier Conde Rueda <xavi.conde@gmail.com>, 2006
+# Josep Torné Llavall <josep.torne@gmail.com>,2009
 #
 # This file is translated according to the glossary and style guide of
 #   Softcatalà. If you plan to modify this file, please read first the page
@@ -98,19 +99,17 @@
 
 #: ../audit2allow/audit2allow:217
 #, fuzzy
-msgid "******************** IMPORTANT ***********************\n"
-msgstr ""
-"\n"
-"******************** IMPORTANT ***********************\n"
+msgid  "******************** IMPORTANT ***********************\n"
+msgstr "******************** IMPORTANT ***********************\n"
 
 #: ../audit2allow/audit2allow:218
 msgid "To make this policy package active, execute:"
 msgstr ""
 
 #: ../semanage/seobject.py:48
-#, fuzzy
+#, fuzzy  
 msgid "Could not create semanage handle"
-msgstr "No s'ha pogut iniciar la transacció del semanage"
+msgstr "No s'ha pogut crear la nansa del semanage"  #handle=nansa?
 
 #: ../semanage/seobject.py:55
 msgid "SELinux policy is not managed or store cannot be accessed."
@@ -127,13 +126,12 @@
 msgstr "No es pot establir la connexió amb el semanage"
 
 #: ../semanage/seobject.py:70
-#, fuzzy
 msgid "Could not test MLS enabled status"
-msgstr "No s'ha pogut establir el rang MLS per a %s"
+msgstr "No s'ha pogut provar l'estat del MLS %s"
 
 #: ../semanage/seobject.py:142 ../semanage/seobject.py:146
 msgid "global"
-msgstr ""
+msgstr "global"
 
 #: ../semanage/seobject.py:206
 #, fuzzy, python-format
@@ -144,13 +142,13 @@
 
 #: ../semanage/seobject.py:239
 msgid "Level"
-msgstr ""
+msgstr "Nivell"
 
 #: ../semanage/seobject.py:239 ../gui/system-config-selinux.glade:651
 #: ../gui/system-config-selinux.glade:2683 ../gui/translationsPage.py:43
 #: ../gui/translationsPage.py:59
 msgid "Translation"
-msgstr ""
+msgstr "Traducció"
 
 #: ../semanage/seobject.py:247 ../semanage/seobject.py:261
 #, python-format
@@ -174,35 +172,33 @@
 
 #: ../semanage/seobject.py:291
 msgid "Not yet implemented"
-msgstr ""
+msgstr "Encara no està implementat"
 
 #: ../semanage/seobject.py:298
 msgid "Could not start semanage transaction"
 msgstr "No s'ha pogut iniciar la transacció del semanage"
 
 #: ../semanage/seobject.py:304
-#, fuzzy
 msgid "Could not commit semanage transaction"
-msgstr "No s'ha pogut iniciar la transacció del semanage"
+msgstr "No s'ha pogut validar la transacció del semanage"
 
 #: ../semanage/seobject.py:314
-#, fuzzy
 msgid "Could not list SELinux modules"
-msgstr "No es pot llistar els usuaris SELinux"
+msgstr "No s'han pogut llistar els mòduls SELinux"
 
 #: ../semanage/seobject.py:325
 msgid "Permissive Types"
-msgstr ""
+msgstr "Tipus permisius"
 
 #: ../semanage/seobject.py:355
 #, python-format
 msgid "Could not set permissive domain %s (module installation failed)"
-msgstr ""
+msgstr "No s'ha pogut establir el domini permisiu %s (la instal·lació del mòdul ha fallat)"
 
 #: ../semanage/seobject.py:369
 #, python-format
 msgid "Could not remove permissive domain %s (remove failed)"
-msgstr ""
+msgstr "No s'ha pogut eliminar el domini permisiu %s (l'eliminació ha fallat)"
 
 #: ../semanage/seobject.py:395 ../semanage/seobject.py:455
 #: ../semanage/seobject.py:501 ../semanage/seobject.py:583
@@ -226,9 +222,9 @@
 msgstr "Ja s'ha definit el mapatge per a %s"
 
 #: ../semanage/seobject.py:406
-#, fuzzy, python-format
+#, python-format
 msgid "Linux Group %s does not exist"
-msgstr "No existeix l'usuari de Linux %s"
+msgstr "No existeix el grup de Linux %s"
 
 #: ../semanage/seobject.py:411
 #, python-format
@@ -263,7 +259,7 @@
 #: ../semanage/seobject.py:444 ../semanage/seobject.py:447
 #, fuzzy
 msgid "add SELinux user mapping"
-msgstr "No s'ha pogut afegir l'usuari SELinux %s"
+msgstr "afegir el mapatge d'usuari SELinux"
 
 #: ../semanage/seobject.py:451
 msgid "Requires seuser or serange"
@@ -300,27 +296,27 @@
 
 #: ../semanage/seobject.py:553 ../semanage/seobject.py:558
 #: ../gui/system-config-selinux.glade:100
+#,fuzzy
 msgid "Login Name"
-msgstr ""
+msgstr "Nom d'entrada"	#al recull no surt Login Name sinó username i login=dades d'entrada
 
 #: ../semanage/seobject.py:553 ../semanage/seobject.py:558
 #: ../semanage/seobject.py:767 ../semanage/seobject.py:772
 #: ../gui/system-config-selinux.glade:128
 #: ../gui/system-config-selinux.glade:1107
 #: ../gui/system-config-selinux.glade:2496 ../gui/usersPage.py:44
-#, fuzzy
 msgid "SELinux User"
-msgstr "Cal el tipus SELinux"
+msgstr "Usuari SELinux"
 
 #: ../semanage/seobject.py:553 ../gui/system-config-selinux.glade:156
 #: ../gui/system-config-selinux.glade:1135
 msgid "MLS/MCS Range"
-msgstr ""
+msgstr "Abast MLS/MCS"
 
 #: ../semanage/seobject.py:579
-#, fuzzy, python-format
+#, python-format
 msgid "You must add at least one role for %s"
-msgstr "No s'ha pogut afegir el context de fitxer per a %s"
+msgstr "Heu d'afegir almenys un rol per %s"
 
 #: ../semanage/seobject.py:587 ../semanage/seobject.py:654
 #: ../semanage/seobject.py:712 ../semanage/seobject.py:718
@@ -407,28 +403,28 @@
 
 #: ../semanage/seobject.py:766
 msgid "Labeling"
-msgstr ""
+msgstr "S'està etiquetant"
 
 #: ../semanage/seobject.py:766
 msgid "MLS/"
-msgstr ""
+msgstr "MLS/"
 
 #: ../semanage/seobject.py:767
 msgid "Prefix"
-msgstr ""
+msgstr "Prefix"
 
 #: ../semanage/seobject.py:767
 msgid "MCS Level"
-msgstr ""
+msgstr "Nivell MCS"
 
 #: ../semanage/seobject.py:767
 msgid "MCS Range"
-msgstr ""
+msgstr "Abast MCS"
 
 #: ../semanage/seobject.py:767 ../semanage/seobject.py:772
 #: ../gui/system-config-selinux.glade:1184 ../gui/usersPage.py:59
 msgid "SELinux Roles"
-msgstr ""
+msgstr "Rols SELinux"
 
 #: ../semanage/seobject.py:787
 msgid "Protocol udp or tcp is required"
@@ -524,14 +520,13 @@
 msgstr "No es pot modificar el port %s/%s"
 
 #: ../semanage/seobject.py:906
-#, fuzzy
 msgid "Could not list the ports"
-msgstr "No s'ha pogut llistar els ports"
+msgstr "No s'han pogut llistar els ports"
 
 #: ../semanage/seobject.py:922
-#, fuzzy, python-format
+#, python-format
 msgid "Could not delete the port %s"
-msgstr "No s'ha pogut suprimir el port %s/%s"
+msgstr "No s'ha pogut suprimir el port %s"
 
 #: ../semanage/seobject.py:939
 #, python-format
@@ -545,11 +540,11 @@
 
 #: ../semanage/seobject.py:959 ../semanage/seobject.py:981
 msgid "Could not list ports"
-msgstr "No s'ha pogut llistar els ports"
+msgstr "No s'han pogut llistar els ports"
 
 #: ../semanage/seobject.py:1002
 msgid "SELinux Port Type"
-msgstr ""
+msgstr "Tipus de port SELinux"
 
 #: ../semanage/seobject.py:1002
 msgid "Proto"
@@ -561,20 +556,18 @@
 
 #: ../semanage/seobject.py:1019 ../semanage/seobject.py:1101
 #: ../semanage/seobject.py:1151
-#, fuzzy
 msgid "Node Address is required"
-msgstr "Cal el port"
+msgstr "L'adreça del node és necessària"
 
 #: ../semanage/seobject.py:1022 ../semanage/seobject.py:1104
 #: ../semanage/seobject.py:1154
-#, fuzzy
 msgid "Node Netmask is required"
-msgstr "Cal el port"
+msgstr "La màscara del node és necessària"
 
 #: ../semanage/seobject.py:1029 ../semanage/seobject.py:1110
 #: ../semanage/seobject.py:1161
 msgid "Unknown or missing protocol"
-msgstr ""
+msgstr "Protocol desconegut o desaparegut"
 
 #: ../semanage/seobject.py:1039 ../semanage/seobject.py:1241
 #: ../semanage/seobject.py:1430
@@ -593,17 +586,17 @@
 #: ../semanage/seobject.py:1169 ../semanage/seobject.py:1175
 #, fuzzy, python-format
 msgid "Could not check if addr %s is defined"
-msgstr "No s'ha pogut comprovar si el port %s/%s està definit"
+msgstr "No s'ha pogut comprovar si l'adreça %s està definida"  #addr->adreça?
 
 #: ../semanage/seobject.py:1049
 #, fuzzy, python-format
 msgid "Addr %s already defined"
-msgstr "El port %s/%s està definit"
+msgstr "L'adreça %s/%s està definida"  #addr->adreça?
 
 #: ../semanage/seobject.py:1053
 #, fuzzy, python-format
 msgid "Could not create addr for %s"
-msgstr "No s'ha pogut crear una clau per a %s"
+msgstr "No s'ha pogut crear l'adreça per a %s" #addr->adreça?
 
 #: ../semanage/seobject.py:1058 ../semanage/seobject.py:1260
 #: ../semanage/seobject.py:1400
@@ -614,17 +607,34 @@
 #: ../semanage/seobject.py:1062
 #, fuzzy, python-format
 msgid "Could not set mask for %s"
-msgstr "No s'ha pogut establir el nom per a %s"
+msgstr "No s'ha pogut establir la màscara per a %s"	#mask->màscara?
 
 #: ../semanage/seobject.py:1067
 #, fuzzy, python-format
 msgid "Could not set user in addr context for %s"
-msgstr "No s'ha pogut establir l'usuari en el context del fitxer per a %s"
+msgstr "No s'ha pogut establir l'usuari en el context de l'adreça per a %s"
 
 #: ../semanage/seobject.py:1071
 #, fuzzy, python-format
 msgid "Could not set role in addr context for %s"
-msgstr "No s'ha pogut establir el rol en el context del fitxer per a %s"
+msgstr "No s'ha pogut establir el rol en el context de l'adreça per a %s"
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
 
 #: ../semanage/seobject.py:1075
 #, fuzzy, python-format
@@ -873,7 +883,7 @@
 
 #: ../semanage/seobject.py:1621
 msgid "type"
-msgstr ""
+msgstr "tipus"
 
 #: ../semanage/seobject.py:1651 ../semanage/seobject.py:1702
 #: ../semanage/seobject.py:1708
@@ -909,7 +919,7 @@
 #: ../semanage/seobject.py:1687
 #, python-format
 msgid "Bad format %s: Record %s"
-msgstr ""
+msgstr "Format incorrecte %s: registre %s"
 
 #: ../semanage/seobject.py:1710
 #, python-format
@@ -927,24 +937,24 @@
 
 #: ../semanage/seobject.py:1762
 msgid "unknown"
-msgstr ""
+msgstr "desconegut"
 
 #: ../semanage/seobject.py:1765
 msgid "off"
-msgstr ""
+msgstr "inactiu"
 
 #: ../semanage/seobject.py:1765
 msgid "on"
-msgstr ""
+msgstr "actiu"
 
 #: ../semanage/seobject.py:1774
 msgid "SELinux boolean"
-msgstr ""
+msgstr "Booleà SELinux"
 
 #: ../semanage/seobject.py:1774 ../gui/polgen.glade:3228
 #: ../gui/polgengui.py:169
 msgid "Description"
-msgstr ""
+msgstr "Descripció"
 
 #: ../newrole/newrole.c:198
 #, c-format
@@ -1171,14 +1181,14 @@
 msgstr "no s'ha pogut obtenir l'old_context.\n"
 
 #: ../newrole/newrole.c:1140
-#, fuzzy, c-format
+#, c-format
 msgid "Warning!  Could not retrieve tty information.\n"
-msgstr "No s'ha pogut obtenir informació de la tty.\n"
+msgstr "Avís! No s'ha pogut obtenir informació de la tty.\n"
 
 #: ../newrole/newrole.c:1161
 #, c-format
 msgid "error on reading PAM service configuration.\n"
-msgstr ""
+msgstr "error en la lectura de la configuració del servei PAM.\n"
 
 #: ../newrole/newrole.c:1196
 #, c-format
@@ -1222,7 +1232,7 @@
 #: ../load_policy/load_policy.c:22
 #, fuzzy, c-format
 msgid "usage:  %s [-qi]\n"
-msgstr "Forma d'ús: %s [-bq]\n"
+msgstr "sintaxi: %s [-qi]\n"	#sintaxi o forma d'ús?
 
 #: ../load_policy/load_policy.c:71
 #, c-format
@@ -1230,9 +1240,9 @@
 msgstr ""
 
 #: ../load_policy/load_policy.c:80
-#, fuzzy, c-format
+#, c-format
 msgid "%s:  Can't load policy and enforcing mode requested:  %s\n"
-msgstr "%s: no es pot carregar la política: %s\n"
+msgstr "%s:  No es pot carregar la política del mode sol·licitat ni fer-la complir: %s\n"
 
 #: ../load_policy/load_policy.c:90
 #, c-format
@@ -1326,22 +1336,22 @@
 
 #: ../gui/booleansPage.py:186 ../gui/system-config-selinux.glade:1917
 msgid "Boolean"
-msgstr ""
+msgstr "Booleà"
 
 #: ../gui/booleansPage.py:241 ../gui/semanagePage.py:162
 msgid "all"
-msgstr ""
+msgstr "tot"
 
 #: ../gui/booleansPage.py:243 ../gui/semanagePage.py:164
 #: ../gui/system-config-selinux.glade:1808
 #: ../gui/system-config-selinux.glade:2031
 #: ../gui/system-config-selinux.glade:2835
 msgid "Customized"
-msgstr ""
+msgstr "Personalitzat"
 
 #: ../gui/fcontextPage.py:64 ../gui/system-config-selinux.glade:2122
 msgid "File Labeling"
-msgstr ""
+msgstr "Etiquetatge de fitxers"
 
 #: ../gui/fcontextPage.py:74
 msgid ""
@@ -1399,7 +1409,7 @@
 
 #: ../gui/modulesPage.py:62
 msgid "Version"
-msgstr ""
+msgstr "Versió"
 
 #: ../gui/modulesPage.py:134
 msgid "Disable Audit"
@@ -1419,11 +1429,11 @@
 
 #: ../gui/polgen.glade:80
 msgid "Red Hat 2007"
-msgstr ""
+msgstr "Red Hat 2007"
 
 #: ../gui/polgen.glade:81
 msgid "GPL"
-msgstr ""
+msgstr "GPL"
 
 #: ../gui/polgen.glade:85 ../gui/system-config-selinux.glade:17
 msgid "translator-credits"
@@ -1431,7 +1441,7 @@
 
 #: ../gui/polgen.glade:91 ../gui/polgen.glade:124
 msgid "SELinux Policy Generation Tool"
-msgstr ""
+msgstr "Eina de generació de polítiques SELinux"
 
 #: ../gui/polgen.glade:125
 msgid ""
@@ -2584,7 +2594,7 @@
 #: ../gui/selinux.tbl:126 ../gui/selinux.tbl:163 ../gui/selinux.tbl:176
 #: ../gui/selinux.tbl:221
 msgid "Samba"
-msgstr ""
+msgstr "Samba"
 
 #: ../gui/selinux.tbl:126
 msgid "Disable SELinux protection for nmbd daemon"
@@ -2648,7 +2658,7 @@
 
 #: ../gui/selinux.tbl:141
 msgid "pppd"
-msgstr ""
+msgstr "pppd"
 
 #: ../gui/selinux.tbl:141
 msgid "Allow pppd to be run for a regular user"
@@ -2732,7 +2742,7 @@
 
 #: ../gui/selinux.tbl:161
 msgid "rsync"
-msgstr ""
+msgstr "rsync"
 
 #: ../gui/selinux.tbl:161
 msgid "Disable SELinux protection for rsync daemon"
@@ -3264,7 +3274,7 @@
 #: ../gui/system-config-selinux.glade:3090
 #: ../gui/system-config-selinux.glade:3265
 msgid "Filter"
-msgstr ""
+msgstr "Filtre"
 
 #: ../gui/system-config-selinux.glade:1945
 msgid "label50"
@@ -3272,15 +3282,15 @@
 
 #: ../gui/system-config-selinux.glade:1982
 msgid "Add File Context"
-msgstr ""
+msgstr "Afegir fitxer de context"
 
 #: ../gui/system-config-selinux.glade:1998
 msgid "Modify File Context"
-msgstr ""
+msgstr "Modificar fitxer de context"
 
 #: ../gui/system-config-selinux.glade:2014
 msgid "Delete File Context"
-msgstr ""
+msgstr "Eliminar fitxer de context"
 
 #: ../gui/system-config-selinux.glade:2030
 msgid "Toggle between all and customized file context"
@@ -3309,18 +3319,17 @@
 msgstr ""
 
 #: ../gui/system-config-selinux.glade:2374
-#, fuzzy
+
 msgid "Add User"
-msgstr "No s'ha pogut afegir l'usuari SELinux %s"
+msgstr "Afegir usuari"
 
 #: ../gui/system-config-selinux.glade:2390
-#, fuzzy
 msgid "Modify User"
-msgstr "No s'ha pogut modificar l'usuari SELinux %s"
+msgstr "Modificar usuari"
 
 #: ../gui/system-config-selinux.glade:2406
 msgid "Delete User"
-msgstr ""
+msgstr "Eliminar usuari"
 
 #: ../gui/system-config-selinux.glade:2524
 msgid "label41"
@@ -3328,15 +3337,15 @@
 
 #: ../gui/system-config-selinux.glade:2561
 msgid "Add Translation"
-msgstr ""
+msgstr "Afegir traducció"
 
 #: ../gui/system-config-selinux.glade:2577
 msgid "Modify Translation"
-msgstr ""
+msgstr "Modificar traducció"
 
 #: ../gui/system-config-selinux.glade:2593
 msgid "Delete Translation"
-msgstr ""
+msgstr "Suprimir traducció"
 
 #: ../gui/system-config-selinux.glade:2711
 msgid "label40"
@@ -3344,15 +3353,15 @@
 
 #: ../gui/system-config-selinux.glade:2748
 msgid "Add Network Port"
-msgstr ""
+msgstr "Afegir port de xarxa"
 
 #: ../gui/system-config-selinux.glade:2764
 msgid "Edit Network Port"
-msgstr ""
+msgstr "Editar port de xarxa"
 
 #: ../gui/system-config-selinux.glade:2780
 msgid "Delete Network Port"
-msgstr ""
+msgstr "Suprimir port de xarxa"
 
 #: ../gui/system-config-selinux.glade:2816
 #: ../gui/system-config-selinux.glade:2834