--- fedora-user-guide_Playing_games_fr(1)1.po	2011-09-23 20:56:21.063045866 +0200
+++ fedora-user-guide_Playing_games_fr(1)2.po	2011-09-24 08:27:36.976778098 +0200
@@ -41,25 +41,25 @@
 "url=\"https://fedoraproject.org/wiki/Games\">https://fedoraproject.org/wiki/Games</ulink>."
 " Pour avoir plus d'informations à propos des jeux de cette liste veuillez consulter le menu "
 "<guilabel>Aide</guilabel> de chaque jeu."
 
 #. Tag: title
 #, no-c-format
 msgid "You do not need to switch desktops to play games"
-msgstr "Vous n'avez pas besoin de changer d'environnement de bureau pour jouer à un jeu"
+msgstr "Vous n'avez pas besoin de changer d'environnement graphique pour jouer à un jeu"
 
 #. Tag: para
 #, no-c-format
 msgid ""
 "You can play KDE games while logged into GNOME and GNOME games while logged "
 "into KDE. Graphical environment components are very modular. When you "
 "install the game packs any dependencies will also be installed. You may need"
 " additional packages to view the online help."
 msgstr ""
-"Vous pouvez jouer à des jeux KDE sous un environnement Gnome et inversement. "
+"Vous pouvez jouer à des jeux KDE sous un environnement GNOME et inversement. "
 "Les composants de l'environnement graphique sont très modulaire. Quand vous "
 "installez un pack de jeux toutes les dépendances sont également installées. "
 "Vous pourriez avoir besoin de paquets supplémentaires pour afficher l'aide en ligne."
 
 #. Tag: title
 #, no-c-format
 msgid "Default GNOME games"
@@ -88,25 +88,25 @@
 #, no-c-format
 msgid "<application>Iagno</application>"
 msgstr "<application>Iagno</application>"
 
 #. Tag: para
 #, no-c-format
 msgid "is a A Reversi-like disk flipping game."
-msgstr "est un jeu de retournement de jeton comme Reversi."
+msgstr "est un jeu de retournement de jeton tel que Reversi."
 
 #. Tag: term
 #, no-c-format
 msgid "<application>Mines</application>"
 msgstr "<application>Mines</application>"
 
 #. Tag: para
 #, no-c-format
 msgid "is a clone of a popular puzzle game."
-msgstr "est un clone d'un jeu de puzzle populaire."
+msgstr "est un clone d'un jeu de réflexion populaire."
 
 #. Tag: term
 #, no-c-format
 msgid "<application>Sudoku</application>"
 msgstr "<application>Sudoku</application>"
 
 #. Tag: para
@@ -159,15 +159,15 @@
 "each game. From the command line, the package name is <package>gnome-games-"
 "help</package>."
 msgstr ""
 "Pour jouer à ces jeux supplémentaires, installez le paquet <package>gnome-games-"
 "extra</package> en utilisant l'<application>application PackageKit</application> "
 "ou depuis la ligne de commande en utilisant <application>Yum</application>. Consultez "
 "<xref linkend=\"chap-User_Guide-Managing_software\" /> pour de l'aide sur l'installation "
-"de nouveaux programmes. assurez-vous d'avoir aussi installé <application>Fichiers d'aide "
+"de nouveaux programmes. Assurez-vous d'avoir aussi installé les <application>fichiers d'aide "
 "pour les jeux GNOME</application> qui fournit le mode d'emploi de chaque "
 "jeux. Depuis la ligne de commande, le nom du paquet est <package>gnome-games-help</package>."
 
 #. Tag: title
 #, no-c-format
 msgid "How to play the games"
 msgstr "Comment jouer à des jeux"
@@ -176,17 +176,17 @@
 #, no-c-format
 msgid ""
 "With <application>Help Files for gnome-games</application> installed, you "
 "can click on the <menuchoice><guimenu>Help </guimenu><guisubmenu> "
 "Contents</guisubmenu></menuchoice> menu in each game to get help on how to "
 "play the game."
 msgstr ""
-"Avec les <application>Fichiers d'aide pour les jeux GNOME</application> installés, vous "
+"Avec les <application>fichiers d'aide pour les jeux GNOME</application> installés, vous "
 "pouvez cliquez sur le menu <menuchoice><guimenu>Aide </guimenu><guisubmenu> "
-"Manuel utilisateur de « nom_du_jeu »</guisubmenu></menuchoice> dans chaque jeu "
+"Sommaire »</guisubmenu></menuchoice> dans chaque jeu "
 "pour obtenir de l'aide sur la façon de jouer." 
 
 #. Tag: title
 #, no-c-format
 msgid "Default KDE games"
 msgstr "Jeux par défaut sous KDE"
 
@@ -202,32 +202,32 @@
 "<package>kdegames</package> package contains games for the current version "
 "of KDE and the <package>kdegames3</package> package contains additional "
 "games which have not yet been ported to KDE4."
 msgstr ""
 "La plupart des jeux ne sont pas installés par défaut depuis le Live-CD ou le DVD. Si vous "
 "n'avez pas accès à internet, vous pouvez utiliser le DVD de Fedora pour les installer, "
 "sinon utilisez l'<application>application PackageKit</application> ou la ligne de commande "
-"avec <application>Yum</application>. Consulter <xref linkend=\"chap-User_Guide-"
-"Managing_software\" /> pour de l'aide sur l'installation de nouveaux logiciels. Le "
+"avec <application>Yum</application>. Consultez <xref linkend=\"chap-User_Guide-"
+"Managing_software\" /> pour obtenir de l'aide sur l'installation de nouveaux logiciels. Le "
 "paquet <package>kdegames</package> contient les jeux pour la version courrante de "
 "KDE alors que le paquet <package>kdegames3</package> contient des jeux supplémentaires "
-"qui n'ont pas encore été intégré à KDE4."
+"qui n'ont pas encore été intégrés à KDE4."
 
 #. Tag: para
 #, no-c-format
 msgid ""
 "The KDE games pack includes popular games similar to those provided by the "
 "GNOME games pack such as Kfourinline, Ksudoku, Kreversi, and many more. A "
 "sampling of other games included in the KDE games pack that may not be in "
 "other game packs include:"
 msgstr ""
-"Le pack de jeux KDE inclus des jeux populaires semblables à ceux fournit par "
-"celui de GNOME comme Kfourinline, Ksudoku, Kreversi et plus encore. Exemples "
-"d'autres jeux fournit par le pack de jeux KDE et qui peuvent ne pas être "
-"fournit par d'autres packs : "
+"Le pack de jeux KDE inclut des jeux populaires semblables à ceux fournis par "
+"GNOME comme Kfourinline, Ksudoku, Kreversi et plus encore. Exemples "
+"d'autres jeux fournis par le paquet de jeux KDE et qui peuvent ne pas être "
+"fournis par d'autres : "
 
 #. Tag: term
 #, no-c-format
 msgid "<application>Kapman</application>"
 msgstr "<application>Kapman</application>"
 
 #. Tag: para