Index: system-config-rootpassword/fr.po
===================================================================
RCS file: /usr/local/CVS/redhat-config-rootpassword/po/fr.po,v
retrieving revision 1.27
diff -U65535 -r1.27 fr.po
--- system-config-rootpassword/fr.po	30 Dec 2006 10:38:33 -0000	1.27
+++ system-config-rootpassword/fr.po	30 Dec 2006 19:32:14 -0000
@@ -1,114 +1,108 @@
-# translation of fr.po to Français
+# translation of fr.po to français
 # Copyright (C) YEAR ORGANIZATION
 #
 # Jean-Paul Aubry <jpaubry@redhat.com>, 2003,2004.
 # Damien Durand <splinux@fedoraproject.org>, 2006.
 # Canniot Thomas <thomas.canniot@laposte.net>, 2006.
+# nihed <nihedmm@gmail.com>, 2006.
 msgid ""
 msgstr ""
 "Project-Id-Version: fr\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2006-11-21 10:56+0000\n"
-"PO-Revision-Date: 2006-12-30 10:59+0100\n"
-"Last-Translator: Canniot Thomas <thomas.canniot@laposte.net>\n"
-"Language-Team: Français <fedora-trans-fr@redhat.com>\n"
+"PO-Revision-Date: 2006-12-30 20:39+0100\n"
+"Last-Translator: nihed <nihedmm@gmail.com>\n"
+"Language-Team: français <fr@li.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Generated-By: pygettext.py 1.4\n"
 "X-Generator: KBabel 1.11.4\n"
 
 #: ../src/passwordDialog.py:50 ../src/passwordDialog.py:90
 #: ../src/passwordDialog.py:185 ../src/rootpassword_tui.py:27
 msgid "Root Password"
-msgstr "Mot de passe root"
+msgstr "Mot de passe superutilisateur"
 
 #: ../src/passwordDialog.py:52
 msgid "Change the root password for the system"
-msgstr "Modifier le mot de passe root pour le système"
+msgstr "Modifier le mot de passe superutilisateur pour le système"
 
 #. If no user was passed in, assume that we're chaning the root password
 #: ../src/passwordDialog.py:95
 msgid "Please set the root password for the system."
-msgstr "Veuillez définir le mot de passe root pour le système."
+msgstr "Veuillez définir le mot de passe superutilisateur pour le système."
 
 #: ../src/passwordDialog.py:98
 #, python-format
 msgid "Please set the password for %s."
 msgstr "Veuillez définir le mot de passe de %s"
 
 #: ../src/passwordDialog.py:103
-#, fuzzy
 msgid "Root Password:"
-msgstr "Mot de passe root "
+msgstr "Mot de passe superutilisateur :"
 
 #: ../src/passwordDialog.py:107
 msgid "Confirm:"
 msgstr "Confirmer :"
 
 #: ../src/passwordDialog.py:127
-#, fuzzy
 msgid "Root password must be at least 6 characters in length."
-msgstr "Le mot de passe root doit comporter une longueur d'au moins 6 caractères."
+msgstr "Le mot de passe superutilisateur doit comporter au moins 6 caractères."
 
 #: ../src/passwordDialog.py:140
-#, fuzzy
 msgid "Passwords do not match.  Please try again."
-msgstr "Les mots de passe que vous avez entrés sont différents. Réessayé à nouveau."
+msgstr "Les mots de passe ne correspondent pas. Essayez à nouveau."
 
 #: ../src/rootpassword_tui.py:29
 msgid ""
 "Pick a root password. You must type it twice to ensure you know what it is "
 "and didn't make a mistake in typing. Remember that the root password is a "
 "critical part of system security!"
-msgstr ""
-"Saisissez un mot de passe root. Vous devez l'écrire deux fois pour pour être "
-"sûr de savoir ce que vous faites et ne pas faire d'erreur en le réécrivant. "
-"Rappelez-vous que le mot de passe root est une partie critique de la "
-"sécurité du système !"
+msgstr "Saisissez le mot de passe superutilisateur. Vous devez l'écrire deux fois pour être sûr que vous le connaissiez et n'avez pas fait d'erreur durant l'écriture. Rappelez-vous que le mot de passe superutilisateur est une partie critique de la sécurité du système!"
 
 #: ../src/rootpassword_tui.py:40
 msgid "Password:"
-msgstr "Mot de passe root : "
+msgstr "Mot de passe superutilisateur :"
 
 #: ../src/rootpassword_tui.py:41
 msgid "Password (confirm):"
-msgstr "Mot de passe (confirmation) : "
+msgstr "Mot de passe (confirmation) :"
 
 #: ../src/rootpassword_tui.py:46 ../src/rootpassword_tui.py:55
 #: ../src/rootpassword_tui.py:69 ../src/rootpassword_tui.py:74
 msgid "OK"
 msgstr "Valider"
 
 #: ../src/rootpassword_tui.py:46
 msgid "Cancel"
 msgstr "Annuler"
 
 #: ../src/rootpassword_tui.py:53
 msgid "Error"
 msgstr "Erreur"
 
 #: ../src/rootpassword_tui.py:54
 msgid "You must be root to change the root password."
-msgstr "Vous devez être root pour changer le mot de passe root."
+msgstr "Vous devez être superutilisateur pour changer le mot de passe superutilisateur."
 
 #: ../src/rootpassword_tui.py:66
 msgid "Password Length"
 msgstr "Longueur du mot de passe"
 
 #: ../src/rootpassword_tui.py:67
 msgid "The root password must be at least 6 characters long."
-msgstr "Le mot de passe root doit comporter une longueur d'au moins 6 caractères."
+msgstr "Le mot de passe superutilisateur doit comporter au moins 6 caractères."
 
 #: ../src/rootpassword_tui.py:71
 msgid "Password Mismatch"
 msgstr "Erreur de mot de passe"
 
 #: ../src/rootpassword_tui.py:72
 msgid "The passwords you entered were different. Please try again."
-msgstr "Les mots de passe que vous avez entrés sont différents. Réessayé à nouveau."
+msgstr "Les mots de passe ne correspondent pas. Essayez à nouveau."
 
 #: ../src/system-config-rootpassword.py:41
 msgid "system-config-rootpassword requires a currently running X server."
 msgstr "system-config-rootpassword néccessite un serveur X en cours d'exécution."
 