--- fedora-web_fedoraproject-org-master_fr.po	2011-09-09 18:00:46.217361587 +0200
+++ fedora-web_fedoraproject-org-master_fr1.po	2011-09-09 18:13:20.000000000 +0200
@@ -11,12 +11,12 @@
 msgid ""
 msgstr ""
 "Project-Id-Version: Fedora Websites\n"
 "Report-Msgid-Bugs-To: EMAIL@ADDRESS\n"
 "POT-Creation-Date: 2011-09-08 22:00+0200\n"
-"PO-Revision-Date: 2011-09-08 20:06+0000\n"
-"Last-Translator: shaiton <shaiton@fedoraproject.org>\n"
+"PO-Revision-Date: 2011-09-09 18:13+0100\n"
+"Last-Translator: Bribanick dominique <chepioq@gmail.com>\n"
 "Language-Team: French <trans-fr@lists.fedoraproject.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Generated-By: Babel 0.9.6\n"
@@ -1303,11 +1303,11 @@
 msgid "Fedora Project - Download Fedora and try it."
 msgstr "Projet Fedora - Télécharger et essayer Fedora."
 
 #: data/content/get-fedora.html:25
 msgid "Did someone say... &ldquo;<a href=\"get-prerelease\">Alpha</a>&rdquo;?"
-msgstr ""
+msgstr "Vous avez dit... &ldquo;<a href=\"get-prerelease\">Alpha</a>&rdquo; ?"
 
 #: data/content/get-fedora.html:30
 #, python-format
 msgid "Fedora %s Desktop Edition"
 msgstr "Fedora %s version GNOME"
@@ -1740,20 +1740,20 @@
 "endroit pour suivre ce qui se fait de plus récent sur Linux et les logiciels"
 " libres. »"
 
 #: data/content/index.html:113
 msgid "Jason Brooks, <a href=\"http://eweek.com/\">eweek.com</a>"
-msgstr ""
+msgstr "Jason Brooks, <a href=\"http://eweek.com/\">eweek.com</a>"
 
 #: data/content/index.html:114
 msgid "\"Fedora has [...] released an amazingly rock-solid operating system.\""
 msgstr ""
 "« Fedora [...] a sorti un système d'exploitation incroyablement solide »"
 
 #: data/content/index.html:115
 msgid "Jack Wallen, <a href=\"http://techrepublic.com/\">TechRepublic.com</a>"
-msgstr ""
+msgstr "Jack Wallen, <a href=\"http://techrepublic.com/\">TechRepublic.com</a>"
 
 #: data/content/index.html:121
 msgid "Need help?"
 msgstr "Besoin d'aide ?"
 
@@ -2346,11 +2346,11 @@
 #: data/content/keys.html:228 data/content/keys.html:243
 #: data/content/keys.html:258 data/content/keys.html:272
 #: data/content/keys.html:286 data/content/keys.html:300
 #, python-format
 msgid "Download: <a href=\"%s\">Fedora Project</a>"
-msgstr ""
+msgstr "Télécharger : <a href=\"%s\">Fedora Project</a>"
 
 #: data/content/keys.html:68 data/content/keys.html:83
 #: data/content/keys.html:97 data/content/keys.html:111
 #: data/content/keys.html:126 data/content/keys.html:140
 #: data/content/keys.html:155 data/content/keys.html:179
@@ -2359,11 +2359,11 @@
 #: data/content/keys.html:259 data/content/keys.html:273
 #: data/content/keys.html:287 data/content/keys.html:301
 #: data/content/keys.html:324
 #, python-format
 msgid "Download: <a href=\"%s\">keys.gnupg.net</a>"
-msgstr ""
+msgstr "Télécharger : <a href=\"%s\">keys.gnupg.net</a>"
 
 #: data/content/keys.html:159
 msgid "Obsolete keys"
 msgstr "Clés obsolètes"
 
@@ -2400,11 +2400,11 @@
 "est obsolète."
 
 #: data/content/keys.html:178
 #, python-format
 msgid "Path: <a href=\"%s\">/etc/pki/rpm-gpg/RPM-GPG-KEY-fedora</a>"
-msgstr ""
+msgstr "Chemin : <a href=\"%s\">/etc/pki/rpm-gpg/RPM-GPG-KEY-fedora</a>"
 
 #: data/content/keys.html:192
 msgid "Fedora (version 7 and newer) testing updates"
 msgstr "Fedora (version 7 et suivantes) mises à jour de test"
 
@@ -2426,11 +2426,11 @@
 "2008-August/msg00012.html</a> pour savoir pourquoi cette clé est obsolète."
 
 #: data/content/keys.html:198
 #, python-format
 msgid "Path: <a href=\"%s\">/etc/pki/rpm-gpg/RPM-GPG-KEY-fedora-test</a>"
-msgstr ""
+msgstr "Chemin : <a href=\"%s\">/etc/pki/rpm-gpg/RPM-GPG-KEY-fedora-test</a>"
 
 #: data/content/keys.html:317
 msgid "Fedora Extras (version 6 and earlier)"
 msgstr "Fedora Extras (version 6 et précédentes)"
 
@@ -2449,11 +2449,11 @@
 " versions suivantes."
 
 #: data/content/keys.html:323
 #, python-format
 msgid "Path: <a href=\"%s\">/etc/pki/rpm-gpg/RPM-GPG-KEY-fedora-extras</a>"
-msgstr ""
+msgstr "Chemin : <a href=\"%s\">/etc/pki/rpm-gpg/RPM-GPG-KEY-fedora-extras</a>"
 
 #: data/content/keys.html:341
 msgid ""
 "This key was used for packages that were released by Fedora Legacy project "
 "to update releases that reached their official EOL.  The Fedora Legacy "
@@ -2609,11 +2609,11 @@
 "Le fichier CHECKSUM devrait avoir une signature correcte depuis l'une des "
 "clés suivantes :"
 
 #: data/content/verify.html:129
 msgid "Fedora 16"
-msgstr ""
+msgstr "Fedora 16"
 
 #: data/content/verify.html:130
 msgid "Fedora 15"
 msgstr "Fedora 15"
 
@@ -7996,11 +7996,11 @@
 msgid "Freedom. Friends. Features. First."
 msgstr "Freedom. Friends. Features. First."
 
 #: data/templates/head.html:23
 msgid "A Red Hat-Sponsored Community Project"
-msgstr ""
+msgstr "Un projet communautaire sponsorisé par Red Hat"
 
 #: data/templates/head.html:32 data/templates/sidebar.html:15
 msgid "Home"
 msgstr "Accueil"
 